﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Media.Imaging;
using System.IO;

namespace SL4Video
{
public partial class MainPage : UserControl
{
public MainPage()
{
    InitializeComponent();
}
//提供音频和视频的方法
CaptureSource video = new CaptureSource();

private void button1_Click(object sender, RoutedEventArgs e)
{
    //获取计算机上的默认视频对象
    VideoCaptureDevice camera = CaptureDeviceConfiguration.GetDefaultVideoCaptureDevice();
    //成功请求到计算机上的视频设备
    if (CaptureDeviceConfiguration.RequestDeviceAccess())
    {
        //设置视频设备为Camera
        video.VideoCaptureDevice = camera;
        //VideoBrush设置源为video
        ShowVideo.SetSource(video);
        ShowVideo.Stretch = Stretch.Fill;
        //开始捕捉视频
        video.Start();
    }
}

private void button3_Click(object sender, RoutedEventArgs e)
{
    //截图
    WriteableBitmap wBitmap = new WriteableBitmap(border1, new MatrixTransform());
    Image img = new Image();
    img.Width = 450;
    img.Margin = new Thickness(2);
    img.Source = wBitmap;
    //保存图片
    if (wBitmap != null)
    {
        SaveFileDialog saveDlg = new SaveFileDialog();
        saveDlg.Filter = "JPEG Files (*.jpeg)|*.jpeg";
        saveDlg.DefaultExt = ".jpeg";

        if ((bool)saveDlg.ShowDialog())
        {
            using (Stream fs = saveDlg.OpenFile())
            {
                SaveToFile(wBitmap, fs);
                MessageBox.Show("图片保存成功");
            }
        }
    }
    this.stackPanel1.Children.Clear();
    this.stackPanel1.Children.Add(img);
}
/// <summary>
/// 保存图片,
/// </summary>
/// <param name="bitmap"></param>
/// <param name="fs"></param>
private static void SaveToFile(WriteableBitmap bitmap, Stream fs)
{
    int width = bitmap.PixelWidth;
    int height = bitmap.PixelHeight;
    int bands = 3;
    byte[][,] raster = new byte[bands][,];

    for (int i = 0; i < bands; i++)
    {
        raster[i] = new byte[width, height];
    }

    for (int row = 0; row < height; row++)
    {
        for (int column = 0; column < width; column++)
        {
            int pixel = bitmap.Pixels[width * row + column];
            raster[0][column, row] = (byte)(pixel >> 16);
            raster[1][column, row] = (byte)(pixel >> 8);
            raster[2][column, row] = (byte)pixel;
        }

    }

    FluxJpeg.Core.ColorModel model = new FluxJpeg.Core.ColorModel 
        { colorspace = FluxJpeg.Core.ColorSpace.RGB };
    FluxJpeg.Core.Image img = new FluxJpeg.Core.Image(model, raster);


    //Encode the Image as a JPEG
    MemoryStream stream = new MemoryStream();
    FluxJpeg.Core.Encoder.JpegEncoder encoder = 
        new FluxJpeg.Core.Encoder.JpegEncoder(img, 100, stream);
    encoder.Encode();

    //Back to the start
    stream.Seek(0, SeekOrigin.Begin);

    //Get teh Bytes and write them to the stream
    byte[] binaryData = new Byte[stream.Length];
    long bytesRead = stream.Read(binaryData, 0, (int)stream.Length);
    fs.Write(binaryData, 0, binaryData.Length);
}
private void button2_Click(object sender, RoutedEventArgs e)
{
    //停止视频
    video.Stop();
}
}
}
